import { CancelledError } from './error';
import { assign } from './tools';
export const cancellable = (promise, abort) => {
    let cancel;
    const cancelable = new Promise((_, reject) => {
        cancel = (strategy) => {
            reject(new CancelledError(strategy));
            abort && abort();
        };
    });
    return assign(Promise.race([promise, cancelable]), { cancel });
};
export const defer = () => {
    const deferred = {};
    deferred.req = new Promise((resolve, reject) => {
        deferred.rs = resolve;
        deferred.rj = reject;
    });
    deferred.req.catch(() => { });
    return deferred;
};
