import { Event, Step, Store } from 'effector';
import { Strategy } from './strategy';
import { CancellablePromise } from './promise';
import { CancelledPayload, DonePayload, FailPayload, FinallyPayload, Handler } from './types';
interface RunnerScope<Payload, Done, Fail> {
    readonly getHandler: () => Handler<Payload, Done>;
    readonly done: Event<DonePayload<Payload, Done>>;
    readonly fail: Event<FailPayload<Payload, Fail>>;
    readonly anyway: Event<FinallyPayload<Payload, Done, Fail>>;
    readonly cancelled: Event<CancelledPayload<Payload>>;
    readonly cancel: Event<void>;
    readonly strategy: Strategy;
    readonly feedback: boolean;
    readonly limit: number;
    readonly running: CancellablePromise<any>[];
    readonly inFlight: Store<number>;
    readonly push: (promise: CancellablePromise<any>) => number;
    readonly unpush: (promise?: CancellablePromise<any>) => number;
    readonly cancelAll: (strategy?: Strategy) => void;
}
export declare const patchRunner: <Payload, Done, Fail>(runner: Step, scope: RunnerScope<Payload, Done, Fail>) => void;
export {};
